local HealingTracker = _G.HealingTracker

local classColors = {
	["None"] = { R = 1, G = 1, B = 1 },
	["Warrior"] = { R = 0.78, G = 0.61, B = 0.43 },
	["Paladin"] = { R = 0.96, G = 0.55, B = 0.73 },
	["Hunter"] = { R = 0.67, G = 0.83, B = 0.45 },
	["Rogue"] = { R = 1, G = 0.96, B = 0.41 },
	["Priest"] = { R = 1, G = 1, B = 1 },
	["Death Knight"] = { R = 0.77, G = 0.12, B = 0.23 },
	["Demon Hunter"] = { R = 0.64, G = 0.19, B = 0.79 },
	["Shaman"] = { R = 0.14, G = 0.35, B = 1 },
	["Mage"] = { R = 0.41, G = 0.80, B = 0.94 },
	["Warlock"] = { R = 0.58, G = 0.51, B = 0.79 },
	["Monk"] = { R = 0.04, G = 0.59, B = 0.45 },
	["Druid"] = { R = 1, G = 0.49, B = 0.04 },
}
	
local classTextures = {
	["None"] = "shaman",
    ["Warrior"] = "warrior",
	["Paladin"] = "paladin",
	["Hunter"] = "hunter",
	["Rogue"] = "rogue",
	["Priest"] = "priest",
	["Death Knight"] = "deathknight",
	["Demon Hunter"] = "demonhunter",
	["Shaman"] = "shaman",
	["Mage"] = "mage",
	["Warlock"] = "warlock",
	["Monk"] = "monk",
	["Druid"] = "druid",
}

local instances = {

    [1712] = {
        Id = 1712,
        Name = "Antorus, the Burning Throne",
        Abbreviation = "Antorus",
        Bosses = {
            ["Varimathras"] = "Varimathras",
            ["Aggramar"] = "Aggramar",
            ["Portal Keeper Hasabel"] = "Portal Keeper Hasabel",
            ["The Coven of Shivarra"] = "The Coven of Shivarra",
            ["F'harg"] = "Felhounds of Sargeras",
            ["Shatug"] = "Felhounds of Sargeras",
            ["Garothi Worldbreaker"] = "Garothi Worldbreaker",
            ["Antoran High Command"] = "Antoran High Command",
            ["Kin'garoth"] = "Kin'garoth",
            ["Imonar the Soulhunter"] = "Imonar the Soulhunter",
            ["Eonar the Life-Binder"] = "Eonar the Life-Binder",
            ["Argus the Unmaker"] = "Argus the Unmaker"
        }
    },

    [1676] = {
        Id = 1676,
        Name = "Tomb of Sargeras",
        Abbreviation = "ToS",
        Bosses = {
            ["Goroth"] = "Goroth",
            ["Harjatan"] = "Harjatan",
            ["Mistress Sassz'ine"] = "Mistress Sassz'ine",
            ["Atrigan"] = "Demonic Inquisition",
            ["Belac"] = "Demonic Inquisition",
            ["Huntress Kasparian"] = "Sisters of the Moon",
            ["Captain Yathae Moonstrike"] = "Sisters of the Moon",
            ["Priestess Lunaspyre"] = "Sisters of the Moon",
            ["Engine of Soul"] = "The Desolate Host",
            ["The Engine of Soul"] = "The Desolate Host",
            ["High Priestess Dejahna"] = "The Desolate Host",
            ["Maiden of Vigilance"] = "Maiden of Vigilance",
            ["Fallen Avatar"] = "Fallen Avatar",
            ["Maiden of Valor"] = "Fallen Avatar",
            ["Kil'jaeden"] = "Kil'jaeden"
        }
    },

    [1530] = {
        Id = 1530,
        Name = "Nighthold",
        Abbreviation = "NH",
        Bosses = {
            ["Skorpyron"] = "Skorpyron",
            ["Chronomatic Anomaly"] = "Chronomatic Anomaly",
            ["Trilliax"] = "Trilliax",
            ["Spellblade Aluriel"] = "Spellblade Aluriel",
            ["Star Augur Etraeus"] = "Star Augur Etraeus",
            ["High Botanist Tel'arn"] = "High Botanist Tel'arn",
            ["Arcanist Tel'arn"] = "High Botanist Tel'arn",
            ["Naturalist Tel'arn"] = "High Botanist Tel'arn",
            ["Naturalist Tel'arn"] = "High Botanist Tel'arn",
            ["Krosus"] = "Krosus",
            ["Tichondrius"] = "Tichondrius",
            ["Elisande"] = "Elisande",
            ["Gul'dan"] = "Gul'dan"
        }
    },
    
    [1648] = {
        Id = 1648,
        Name = "Trial of Valor",
        Abbreviation = "ToV",
        Bosses = {
            ["Hymdall"] = "Odyn",
            ["Hyrja"] = "Odyn",
            ["Odyn"] = "Odyn",
            ["Guarm"] = "Guarm",
            ["Helya"] = "Helya"
        }
    },

    [1520] = {
        Id = 1520,
        Name = "The Emerald Nightmare",
        Abbreviation = "EN",
        Bosses = {
            ["Nythendra"] = "Nythendra",
            ["Elerethe Renferal"] = "Elerethe Renferal",
            ["Ursoc"] = "Ursoc",
            ["Il'gynoth"] = "Il'gynoth",
            ["Lethon"] = "Dragons of Nightmare",
            ["Taerar"] = "Dragons of Nightmare",
            ["Emeriss"] = "Dragons of Nightmare",
            ["Cenarius"] = "Cenarius",
            ["Xavius"] = "Xavius"
        }
    },

    [1466] = {
        Id = 1466,
        Name = "Darkheart Thicket",
        Abbreviation = "DHT",
        Bosses = {
            ["Archdruid Glaidalis"] = "Archdruid Glaidalis",
            ["Oakheart"] = "Oakheart",
            ["Dresaron"] = "Dresaron",
            ["Shade of Xavius"] = "Shade of Xavius"
        }
    },
    
    [1456] = {
        Id = 1456,
        Name = "Eye of Azshara",
        Abbreviation = "EoA",
        Bosses = {
            ["Warlord Parjesh"] = "Warlord Parjesh",
            ["Lady Hatecoil"] = "Lady Hatecoil",
            ["Serpentrix"] = "Serpentrix",
            ["King Deepbeard"] = "King Deepbeard",
            ["Wrath of Azshara"] = "Wrath of Azshara"
        }
    },
    
    [1477] = {
        Id = 1477,
        Name = "Halls of Valor",
        Abbreviation = "HoV",
        Bosses = {
            ["Hymdall"] = "Hymdall",
            ["Hyrja"] = "Hyrja",
            ["Fenryr"] = "Fenryr",
            ["God-King Skovald"] = "God-King Skovald",
            ["Odyn"] = "Odyn"
        }
    },
    
    [1458] = {
        Id = 1458,
        Name = "Neltharion's Lair",
        Abbreviation = "NL",
        Bosses = {
            ["Rokmora"] = "Rokmora",
            ["Ularogg Cragshaper"] = "Ularogg Cragshaper",
            ["Naraxas"] = "Naraxas",
            ["Dargrul"] = "Dargrul"
        }
    },
    
    [1544] = {
        Id = 1544,
        Name = "Violet Hold",
        Abbreviation = "VH",
        Bosses = {
            ["Mindflayer Kaahrj"] = "Mindflayer Kaahrj",
            ["Millificent Manastorm"] = "Millificent Manastorm",
            ["Festerface"] = "Festerface",
            ["Shivermaw"] = "Shivermaw",
            ["Anub'esset"] = "Anub'esset",
            ["Sael'orn"] = "Sael'orn",
            ["Blood-Princess Thal'ena"] = "Blood-Princess Thal'ena",
            ["Fel Lord Betrug"] = "Fel Lord Betrug"
        }
    },
    
    [1501] = {
        Id = 1501,
        Name = "Black Rook Hold",
        Abbreviation = "BRH",
        Bosses = {
            ["Amalgam of Souls"] = "Amalgam of Souls",
            ["Illysanna Ravencrest"] = "Illysanna Ravencrest",
            ["Smashspite the Hateful"] = "Smashspite the Hateful",
            ["Lord Kur'talos Ravencrest"] = "Lord Kur'talos Ravencrest"
        }
    },
    
    [1571] = {
        Id = 1571,
        Name = "Court of Stars",
        Abbreviation = "CoS",
        Bosses = {
            ["Patrol Captain Gerdo"] = "Patrol Captain Gerdo",
            ["Talixae Flamewreath"] = "Talixae Flamewreath",
            ["Advisor Melandrus"] = "Advisor Melandrus"
        }
    },
    
    [1492] = {
        Id = 1492,
        Name = "Maw of Souls",
        Abbreviation = "MoS",
        Bosses = {
            ["Ymiron, the Fallen King"] = "Ymiron, the Fallen King",
            ["Harbaron"] = "Harbaron",
            ["Helya"] = "Helya"
        }
    },
    
    [1651] = {
        Id = 1651,
        Name = "Return to Karazhan",
        Abbreviation = "Karazhan",
        Bosses = {
            ["Shade of Medivh"] = "Shade of Medivh",
            ["Mana Devourer"] = "Mana Devourer",
            ["Maiden of Virtue"] = "Maiden of Virtue",
            ["Opera Hall: Wikket"] = "Opera Hall",
            ["Opera Hall: Westfall Story "] = "Opera Hall",
            ["Opera Hall: Beautiful Beast"] = "Opera Hall",
            ["Attumen the Huntsman"] = "Attumen the Huntsman",
            ["The Curator"] = "The Curator",
            ["Moroes"] = "Moroes",
            ["Viz'aduum the Watcher"] = "Viz'aduum the Watcher"
        }
    },
    
    [1516] = {
        Id = 1516,
        Name = "The Arcway",
        Abbreviation = "Arc",
        Bosses = {
            ["Corstilax"] = "Corstilax",
            ["Ivanyr"] = "Ivanyr",
            ["General Xakal"] = "General Xakal",
            ["Nal'tira"] = "Nal'tira",
            ["Advisor Vandros"] = "Advisor Vandros"
        }
    },
    
    [1493] = {
        Id = 1493,
        Name = "Vault of the Wardens",
        Abbreviation = "VotW",
        Bosses = {
            ["Tirathon Saltheril"] = "Tirathon Saltheril",
            ["Inquisitor Tormentorum"] = "Inquisitor Tormentorum",
            ["Glazer"] = "Glazer",
            ["Ash'Golm"] = "Ash'Golm",
            ["Cordana Felsong"] = "Cordana Felsong"
        }
    },
    
    [1677] = {
        Id = 1677,
        Name = "Cathedral of Eternal Night",
        Abbreviation = "CoEN",
        Bosses = {
            ["Mephistroth"] = "Mephistroth",
            ["Domatrax"] = "Domatrax",
            ["Agronox"] = "Agronox",
            ["Thrashbite the Scornful"] = "Thrashbite the Scornful"
        }
    },
    
    [1753] = {
        Id = 1753,
        Name = "Seat of the Triumvirate",
        Abbreviation = "Seat",
        Bosses = {
            ["Zuraal the Ascended"] = "Zuraal the Ascended",
            ["Saprish"] = "Saprish",
            ["Viceroy Nezhar"] = "Viceroy Nezhar",
            ["L'ura"] = "L'ura"
        }
    }

}

local innervate = 29166
local targetSpells = {116849, 6940, 633, 1022, 204018, 47788, 73325, 33206}
local nontargetSpells = {740, 108280, 108281, 114052, 98008, 79206, 207399, 192077, 31821, 204150, 31842, 115310, 198664, 62618, 64843, 64901, 97462, 15286, 196718}

local emergencyTable = { 1, 2, 4, 6, 8, 10, 12, 14, 16, 19, 22, 25, 28, 30, 32, 34, 36, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 48, 49, 49, 50, 50, 50, 50, 51, 51, 51, 52, 52, 52, 52, 53, 53, 53, 54, 54, 54, 54, 55}
local regularTable = { 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 30, 30, 31, 31, 31, 32, 32, 32, 33, 33, 33, 34, 34, 34, 35, 35, 35, 36, 36, 36}

_G["ClassColors"] = classColors
_G["ClassTextures"] = classTextures
_G["Instances"] = instances
_G["EmergencyTable"] = emergencyTable
_G["RegularTable"] = regularTable

HealingTracker.Constants.ClassColors = classColors
HealingTracker.Constants.ClassTextures = classTextures
HealingTracker.Constants.Instances = instances
HealingTracker.Constants.EmergencyTable = emergencyTable
HealingTracker.Constants.RegularTable = regularTable
HealingTracker.Constants.TargetSpells = targetSpells
HealingTracker.Constants.NonTargetSpells = nontargetSpells
HealingTracker.Constants.Innervate = innervate

local Helper = HealingTracker.Helper

function Helper:PSHTableSort(item1, item2)
	return item1.AidfulHeal < item2.AidfulHeal
end

function Helper:PSPTableSort(item1, item2)
	return (item1.PointMultiply + item1.PointRegular) < (item2.PointMultiply + item2.PointRegular)
end

function Helper:TotalHealTableSort(item1, item2)
	return (item1.AidfulHeal + item1.PointlessHeal + item1.AidfulPeriodicHeal + item1.PointlessPeriodicHeal) < (item2.AidfulHeal + item2.PointlessHeal + item2.AidfulPeriodicHeal + item2.PointlessPeriodicHeal)
end

function Helper:AidfulHealTableSort(item1, item2)
	return (item1.AidfulHeal + item1.AidfulPeriodicHeal) < (item2.AidfulHeal + item2.AidfulPeriodicHeal)
end

function Helper:PointlessHealTableSort(item1, item2)
	return (item1.PointlessHeal + item1.PointlessPeriodicHeal) < (item2.PointlessHeal + item2.PointlessPeriodicHeal)
end

function Helper:TrackPointTableSort(item1, item2)
	return (item1.TotalMultiply + item1.TotalRegular) < (item2.TotalMultiply + item2.TotalRegular)
end

function Helper:GTTableSort(item1, item2)
	return (item1.TotalMultiply + item1.TotalRegular) < (item2.TotalMultiply + item2.TotalRegular)
end

function Helper:SpellTotalHealTableSort(item1, item2)
	return (item1.AidfulHeal + item1.PointlessHeal + item1.AidfulPeriodicHeal + item1.PointlessPeriodicHeal) < (item2.AidfulHeal + item2.PointlessHeal + item2.AidfulPeriodicHeal + item2.PointlessPeriodicHeal)
end

function Helper:SpellAidfulHealTableSort(item1, item2)
	return (item1.AidfulHeal + item1.AidfulPeriodicHeal) < (item2.AidfulHeal + item2.AidfulPeriodicHeal)
end

function Helper:SpellPointlessHealTableSort(item1, item2)
	return (item1.PointlessHeal + item1.PointlessPeriodicHeal) < (item2.PointlessHeal + item2.PointlessPeriodicHeal)
end

function Helper:SpellTrackPointTableSort(item1, item2)
	return (item1.PointMultiply + item1.PointRegular) < (item2.PointMultiply + item2.PointRegular)
end

function Helper:GUP(c)
	local f = UnitHealthMax(c)
	local n = UnitHealth(c)
	local r = n * 100 / f
	return math.floor(r)
end

function Helper:ReadableNumber(v)
    if v == nil then return "0" end
	if v <= 9999 then
		return v
	elseif v >= 1000000000 then
		return format("%.2fB", v/1000000000)
	elseif v >= 1000000 then
		return format("%.2fM", v/1000000)
	elseif v >= 10000 then
		return format("%.1fK", v/1000)
	else
		return v
	end
end

function Helper:SortSpells(player, sorter)
    local slogs = player.Spells
    for c=0,#slogs,1 do
        for i=#slogs,2,-1 do
            local cur = slogs[i]
            local prev = slogs[i - 1]
                
            if cur ~= nil and prev ~= nil then
                local cv = false
                if sorter == 1 then -- point
                    cv = Helper:SpellTrackPointTableSort(prev, cur)
                elseif sorter == 2 then -- total heal
                    cv = Helper:SpellTotalHealTableSort(prev, cur)
                elseif sorter == 3 then -- aidful heal
                    cv = Helper:SpellAidfulHealTableSort(prev, cur)
                elseif sorter == 4 then -- pointless heal
                    cv = Helper:SpellPointlessHealTableSort(prev, cur)
                else
                    cv = Helper:SpellTrackPointTableSort(prev, cur)
                end
                if cv == true then
                    slogs[i] = prev
                    slogs[i - 1] = cur
                end
                else
                    break
                end
            end
        end
    return slogs
end

function Helper:GetTimeSpan(seconds)

    local mins = 0
    local secs = seconds
    while secs > 59 do
        secs = secs - 60
        mins = mins + 1
    end

    local secs_str = tostring(secs)
    local mins_str = tostring(mins)

    if string.len(secs_str) < 2 then
        secs_str = "0"..secs_str
    end
    
    if string.len(mins_str) < 2 then
        mins_str = "0"..mins_str
    end
    
    return mins_str..":"..secs_str

end